/*
    Based on Neil Kolban example for IDF: https://github.com/nkolban/esp32-snippets/blob/master/cpp_utils/tests/BLE%20Tests/SampleServer.cpp
    Ported to Arduino ESP32 by Evandro Copercini
    updates by chegewara
*/

#include <Arduino.h>

#include <BLEDevice.h>
#include <BLEUtils.h>
#include <BLEServer.h>

// See the following for generating UUIDs:
// https://www.uuidgenerator.net/

#define LED_SERVICE_UUID                "265e1d94-feb2-468e-803f-b4306c063b94"
#define LED_CHARACTERISTIC_UUID         "efdd5df2-2a87-4988-a8cc-19a6696e15e3"

BLECharacteristic *pCharacteristic;
void setup() {
  Serial.begin(9600);
  Serial.println("Starting BLE work!");

  BLEDevice::init("Manuel ");
  BLEServer *pServer = BLEDevice::createServer(); //starting service
  BLEService *pService = pServer->createService(LED_SERVICE_UUID); //getting unique ID
  /*BLECharacteristic * */
  pCharacteristic = pService->createCharacteristic(
                                         LED_CHARACTERISTIC_UUID,
                                         BLECharacteristic::PROPERTY_READ |
                                         BLECharacteristic::PROPERTY_WRITE
                                       );

  pCharacteristic->setValue("Initial value");
  pService->start();
  // BLEAdvertising *pAdvertising = pServer->getAdvertising();  // this still is working for backward compatibility
  BLEAdvertising *pAdvertising = BLEDevice::getAdvertising();
  pAdvertising->addServiceUUID(LED_SERVICE_UUID);
  pAdvertising->setScanResponse(true);
  pAdvertising->setMinPreferred(0x06);  // functions that help with iPhone connections issue
  pAdvertising->setMinPreferred(0x12);
  BLEDevice::startAdvertising();
  Serial.println("Characteristic defined! Now you can read it in your phone!");
}

int i = 0;

void loop() 
{
  if(i++%10==0)
  {
    String str = "value is: " + String(i);
    pCharacteristic->setValue(str.c_str());
  }

  std::string res = pCharacteristic->getValue();
  Serial.println(res.c_str());
      
  delay(1000);
}
